/*
STAR standard functions for data showing

1997/12/11 T.Handa
*/
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <math.h>

#include <StData.h>
#include <StStd.h>

#include <Pxplib.h>
#include <PxpGlib.h>
#include <StPxpShow.h>

void StarPxpRange2Range(px,st)
PxpRange px;
RANGE *st;
/*
1997/12/11 T.Handa
*/
{
	(*st).min=px.min;
	(*st).max=px.max;
}

void StarRange2PxpRange(st,px)
RANGE st;
PxpRange *px;
/*
1997/12/11 T.Handa
*/
{
	(*px).min=st.min;
	(*px).max=st.max;
}

void StarPxpPoint2BoxRange(min,max,box_range)
PxpPoint min,max;
BOX_RANGE *box_range;
/*
1997/12/11 T.Handa
*/
{
	(*box_range).x.min=min.x;
	(*box_range).x.max=max.x;
	(*box_range).y.min=min.y;
	(*box_range).y.max=max.y;
}

void StarBoxRange2PxpPoint(box_range,min,max)
BOX_RANGE box_range;
PxpPoint *min,*max;
/*
1997/12/11 T.Handa
*/
{
	(*min).x=box_range.x.min;
	(*min).y=box_range.y.min;
	(*max).x=box_range.x.max;
	(*max).y=box_range.y.max;
}
