/*
make stdout 
convert angle in Star standard angle format to the value in degree
for option input field

2003/3/4 T.Handa : ver.1.00
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <StStdlib.h>

int main(argc,argv)
int argc;
char *argv[];
{
  double angle;

  if(argc<2) {
    fprintf(stderr,"Usage: %s StarStdAngle\n",argv[0]);
    fprintf(stderr,"About StarStdAngle, read the UltraSTAR manual.\n");
    fprintf(stderr,"Examle input is -12d15M11.5S or 1h15m22s.\n");
    exit(1);
  }

  angle=StarStdAngle2deg(argv[1]);

  fprintf(stdout,"%e",angle);
}
