/*
print stderr of the header of PROFILE

1993/1/19 T.Handa ver.1.0
1993/1/16 T.Handa ver.1.01 (debug) show AzEl
1996/2/27 T.Handa ver.1.10 : for data ver3, code message characterize
1997/11/28 T.Handa : ver.3.00 multi_pipe and new library
1998/3/19 T.Handa : ver.3.01 debug for Solaris2 fcc
1998/4/ 8 T.Handa : ver.3.20 (revise) .scn,.sdb
1998/5/18 T.Handa : ver.3.21 (debug) baseline & spurious flags
1998/5/23 T.Handa : ver.3.22 (update) -none, -no_label options
1999/7/31 T.Handa : ver.3.23 (update) for ver4
2000/2/29 T.Handa : ver.3.24 (debug) function calling
2005/12/24 T.Handa : ver.3.25 (update) for a single line output
       -output short_format/-1l for scd_numb,ctime(obs_date),scd_name,l,b,RA,Dec,Az,El,Vlsr,rms
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include <StData.h>
#include <StStd.h>

#define	DEFAULT_PRMFILE	"headlist.prm"
#define N_KEY 40
#define N_BLOCK	10

void expand_flag(list_flag,block_flag)
PRF_HEADER *list_flag;
int *block_flag;
{
  if(block_flag[0]>0) {
  }	
  if(block_flag[1]>0) {
  }	
  if(block_flag[2]>0) {
  }	
  if(block_flag[3]>0) {
  }	
  if(block_flag[4]>0) {
  }	
  if(block_flag[5]>0) {
  }	
  if(block_flag[6]>0) {
  }	
  if(block_flag[7]>0) {
  }	
  if(block_flag[8]>0) {
  }	
  if(block_flag[9]>0) {
  }	
}

int options(argc,argv,block_flag,list_flag,pipe_flag,label_flag,short_flag,msg_fp_flag)
/*
get parameters from options
*/
int argc;
char *argv[];
int *block_flag;
PRF_HEADER *list_flag;
int *pipe_flag;
int *label_flag;
int *short_flag;
int *msg_fp_flag;
{
  int ii;
  char **keyword;
  char **value;
  int n_key;
  int key_flag[N_KEY];
  int key_type[N_KEY];
  int scan_flag[N_KEY];
  int flag,all_flag;

  char *got_value;

/* default values */
  for(ii=0;ii<N_BLOCK;ii++) {
    block_flag[ii]= -1;
  }
  *pipe_flag= -1;
  *label_flag= 1;
  all_flag= -1;
  *short_flag= -1;
  *msg_fp_flag= 2;

/* set keywords with scan_flag */
  keyword=AllocWordsStrage(N_KEY);
  value=AllocWordsStrage(N_KEY);

  n_key=AddNewWord(keyword,"pipe");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"output");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"-");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"nopipe");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"sys_head");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"system");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"observation");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"obs");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"object");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"obj");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"antenna");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"ant");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"receiver");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"rx");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"backend");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"be");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"obs_log");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"log");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"history");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"hist");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"spurious");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"sp");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"baseline");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"bs");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"all");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"none");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"label");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"no_label"); key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"msg_format"); key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"short_msg"); key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"msg_output"); key_type[n_key-1]=1;

  StarGetOption(argc,argv,DEFAULT_PRMFILE,n_key,keyword,key_flag,value);

/* pipe */
  scan_flag[0]=0;
  scan_flag[1]=1;
  scan_flag[2]=2;
  scan_flag[3]= -3;
  *pipe_flag=StarOptionFlag(4,scan_flag,key_flag);

/* system */
  scan_flag[0]=4;
  scan_flag[1]=5;
  flag=StarOptionFlag(2,scan_flag,key_flag);
  if(flag!=0) block_flag[0]=flag;

/* observation */
  scan_flag[0]=6;
  scan_flag[1]=7;
  flag=StarOptionFlag(2,scan_flag,key_flag);
  if(flag!=0) block_flag[1]=flag;

/* object */
  scan_flag[0]=8;
  scan_flag[1]=9;
  flag=StarOptionFlag(2,scan_flag,key_flag);
  if(flag!=0) block_flag[2]=flag;

/* antenna */
  scan_flag[0]=10;
  scan_flag[1]=11;
  flag=StarOptionFlag(2,scan_flag,key_flag);
  if(flag!=0) block_flag[3]=flag;

/* receiver */
  scan_flag[0]=12;
  scan_flag[1]=13;
  flag=StarOptionFlag(2,scan_flag,key_flag);
  if(flag!=0) block_flag[4]=flag;

/* backend */
  scan_flag[0]=14;
  scan_flag[1]=15;
  flag=StarOptionFlag(2,scan_flag,key_flag);
  if(flag!=0) block_flag[5]=flag;

/* observation log */
  scan_flag[0]=16;
  scan_flag[1]=17;
  flag=StarOptionFlag(2,scan_flag,key_flag);
  if(flag!=0) block_flag[6]=flag;

/* processing history */
  scan_flag[0]=18;
  scan_flag[1]=19;
  flag=StarOptionFlag(2,scan_flag,key_flag);
  if(flag!=0) block_flag[7]=flag;

/* spurious */
  scan_flag[0]=20;
  scan_flag[1]=21;
  flag=StarOptionFlag(2,scan_flag,key_flag);
  if(flag!=0) block_flag[8]=flag;

/* baseline */
  scan_flag[0]=22;
  scan_flag[1]=23;
  flag=StarOptionFlag(2,scan_flag,key_flag);
  if(flag!=0) block_flag[9]=flag;

/* all */
  scan_flag[0]=24;
  scan_flag[1]= -25;
  flag=StarOptionFlag(2,scan_flag,key_flag);
  if(flag!=0) all_flag=flag;

/* label */
  scan_flag[0]=26;
  scan_flag[1]= -27;
  flag=StarOptionFlag(2,scan_flag,key_flag);
  if(flag!=0) *label_flag=flag;

/* msg format */
  scan_flag[0]=28;
  scan_flag[1]=29;
  got_value=StarOptionValue(2,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    if(strncmp(got_value,"s",1)==0 || strncmp(got_value,"1",1)==0) {
      *short_flag= 1;
    } else if(strncmp(got_value,"d",1)==0 || strncmp(got_value,"2",1)==0) {
      *short_flag= 2;
    } else {
      *short_flag= -1;
    }
  }

/* msg output */
  scan_flag[0]=30;
  got_value=StarOptionValue(1,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    if(strcmp(got_value,"stdout")==0 || strcmp(got_value,"-")==0) {
      *msg_fp_flag= 1; // stdout
    } else {
      *msg_fp_flag= 2; // stderr
    }
    if(*pipe_flag==1) *msg_fp_flag=2;
  }

/* free memory areas */
  StarFreeAllPrms(N_KEY,key_flag,value);
  free(keyword);

/* flag process */
  if(all_flag>0) {
    for(ii=0;ii<8;ii++) block_flag[ii]=1;
    *label_flag= -1;
  }

  return(0);
}

void print_sys_head(msg_fp,list_flag,profile,label_flag)
FILE *msg_fp; /* <in> */
PRF_HEADER *list_flag;
PROFILE *profile;
int label_flag;
{
  fprintf(msg_fp,"total byte=%ld, header length=%d, format=%d, version=%d\n",
	  (*profile).sys_head.l_file,(*profile).sys_head.l_head,
	  (*profile).sys_head.format_id,(*profile).sys_head.version);
  fprintf(msg_fp,"data type=%d=",(*profile).sys_head.data_type);
  switch((*profile).sys_head.data_type){
  case TA_DATA:
    fprintf(msg_fp,"Ta data"); break;
  case FREQSW_RAW_DATA:
    fprintf(msg_fp,"unfold FreqSW data"); break;
  case RAWLONG_DATA:
    fprintf(msg_fp,"Raw BE data (long)"); break;
  case RAWFLOAT_DATA:	
    fprintf(msg_fp,"Raw BE data (float)"); break;
  default:
    fprintf(msg_fp,"unknow type data"); break;
  }
  fprintf(msg_fp,"\n");
  fprintf(msg_fp,"history step=%d, history lines=%d\n",
	  (*profile).sys_head.hist_step,(*profile).sys_head.hist_line);
  fprintf(msg_fp,"scan No.%ld, back up version=%d, original scans=%d\n",
	  (*profile).sys_head.scan,(*profile).sys_head.backup,
	  (*profile).sys_head.num_scan);
}

void print_obs_prm(msg_fp,list_flag,profile,label_flag)
FILE *msg_fp; /* <in> */
PRF_HEADER *list_flag;
PROFILE *profile;
int label_flag;
{
  long	time_in_sec;

  fprintf(msg_fp,"project=%s\n",(*profile).obs_prm.project);
  fprintf(msg_fp,"schedule file=%s, ",(*profile).obs_prm.scd_file);
  fprintf(msg_fp,"line in schedule file=%d\n",(*profile).obs_prm.line_numb);
  fprintf(msg_fp,"swiching mode=%d=",(*profile).obs_prm.sw_mode);
  switch((*profile).obs_prm.sw_mode){
  case TOTAL_POWER:
    fprintf(msg_fp,"Total power"); break;
  case ONOFF_SW:
    fprintf(msg_fp,"OnOff"); break;
  case FREQ_SW:
    fprintf(msg_fp,"Frequency"); break;
  case DICKE_SW:
    fprintf(msg_fp,"Dicke"); break;
  default:
    fprintf(msg_fp,"unknow type"); break;
  }
  fprintf(msg_fp,"\n");
  fprintf(msg_fp,"obs MJD=%ld\n",(*profile).obs_prm.mjd);
  time_in_sec=(*profile).obs_prm.start;
  fprintf(msg_fp,"start=%s",ctime(&time_in_sec));
  time_in_sec=(*profile).obs_prm.stop;
  fprintf(msg_fp,"stop=%s",ctime(&time_in_sec));
  fprintf(msg_fp,"on time=%d, off_time=%d\n",(*profile).obs_prm.on_time,
	  (*profile).obs_prm.off_time);
  fprintf(msg_fp,"observer=%s, %s, %s, %s\n",(*profile).obs_prm.observer1,
	  (*profile).obs_prm.observer2,(*profile).obs_prm.observer3,
	  (*profile).obs_prm.observer4);
}

void print_object(msg_fp,list_flag,profile,label_flag)
FILE *msg_fp; /* <in> */
PRF_HEADER *list_flag;
PROFILE *profile;
int label_flag;
{
  fprintf(msg_fp,"object=%s\n",(*profile).object.name);
  fprintf(msg_fp,"coordinates=%d=",(*profile).object.cood_sys);
  switch((*profile).object.cood_sys){
  case COORD_LB:
    fprintf(msg_fp,"lb"); break;
  case COORD_RADEC:
    fprintf(msg_fp,"RADec(%s)",(*profile).object.equinox); break;
  case COORD_RADEC_APP:
    fprintf(msg_fp,"RADec(app)"); break;
  case COORD_AZEL:	
    fprintf(msg_fp,"AzEl"); break;
  default:
    fprintf(msg_fp,"unknown"); break;
  }
  fprintf(msg_fp,"\n - on -\nl=%f deg, b=%f deg R.A.=%f deg, Dec=%f deg\n",
	  (*profile).object.on_lb.x,(*profile).object.on_lb.y,
	  (*profile).object.on_radec.x,(*profile).object.on_radec.y);
  fprintf(msg_fp,"Az=%f deg, El=%f deg\n",
	  (*profile).object.on_azel.x,(*profile).object.on_azel.y);
  fprintf(msg_fp," - off -\nl=%f deg, b=%f deg, R.A.=%f deg, Dec=%f deg\n",
	  (*profile).object.off_lb.x,(*profile).object.off_lb.y,
	  (*profile).object.off_radec.x,(*profile).object.off_radec.y);
  fprintf(msg_fp,"origin of the local coordinate x=%f deg, y=%f deg, PA=%f deg\n",
	  (*profile).object.orig_xy.x,(*profile).object.orig_xy.y,
	  (*profile).object.pa_xy);
  fprintf(msg_fp,"on in the local coordinate x=%f deg, y=%f deg\n",
	  (*profile).object.on_xy.x,(*profile).object.on_xy.y);
  fprintf(msg_fp,"on position offset Az=%f deg, El=%f deg\n",
	  (*profile).object.azel_offset.x,(*profile).object.azel_offset.y);
}

void print_antenna(msg_fp,list_flag,profile,label_flag)
FILE *msg_fp; /* <in> */
PRF_HEADER *list_flag;
PROFILE *profile;
int label_flag;
{
  fprintf(msg_fp,"telescope=%s\n",(*profile).ant_status.tele);
  fprintf(msg_fp,"efficiencies  ap=%f, beam=%f, fss=%f\n",
	  (*profile).ant_status.ap_eff,(*profile).ant_status.mb_eff,
	  (*profile).ant_status.fss_eff);
  fprintf(msg_fp,"HPBW=%f deg=%f arcmin=%f arcsec\n",(*profile).ant_status.hpbw/60.0,(*profile).ant_status.hpbw,(*profile).ant_status.hpbw*60.0);
}

void print_receiver(msg_fp,list_flag,profile,label_flag)
FILE *msg_fp; /* <in> */
PRF_HEADER *list_flag;
PROFILE *profile;
int label_flag;
{
  fprintf(msg_fp,"receiver name=%s\n",(*profile).rx_status.name);
  fprintf(msg_fp,"sideband mode=%d=",(*profile).rx_status.sb_mode);
  switch((*profile).rx_status.sb_mode){
  case LSB_SSB:
    fprintf(msg_fp,"LSB SSB"); break;
  case LSB_DSB:
    fprintf(msg_fp,"LSB(track) DSB"); break;
  case USB_SSB:
    fprintf(msg_fp,"USB SSB"); break;
  case USB_DSB:	
    fprintf(msg_fp,"USB(track) DSB"); break;
  default:
    fprintf(msg_fp,"unknown"); break;
  }
  fprintf(msg_fp,"\n");
  fprintf(msg_fp,"Vlsr=%f km/s",(*profile).rx_status.v_lsr);
  if((*profile).sys_head.version>2){
    fprintf(msg_fp,", Vlsr(off)=%f km/s",(*profile).rx_status.v_off);
  }
  fprintf(msg_fp,"\n");
  fprintf(msg_fp,"rest freq=%f GHz, obs freq=%f GHz\n",
	  (*profile).rx_status.rest_freq,(*profile).rx_status.obs_freq);
  fprintf(msg_fp,"LO freq(1)=%f GHz, IF(1)=%f GHz, multiplex(1)=%d\n",
	  (*profile).rx_status.lo_freq1,(*profile).rx_status.if_freq1,
	  (*profile).rx_status.mltplx1);
  fprintf(msg_fp,"LO freq(2)=%f GHz, IF(2)=%f GHz, multiplex(2)=%d\n",
	  (*profile).rx_status.lo_freq2,(*profile).rx_status.if_freq2,
	  (*profile).rx_status.mltplx2);
  fprintf(msg_fp,"LO freq(3)=%f GHz, IF(3)=%f GHz, multiplex(3)=%d\n",
	  (*profile).rx_status.lo_freq3,(*profile).rx_status.if_freq3,
	  (*profile).rx_status.mltplx3);
  fprintf(msg_fp,"Tsys=%f K, Trx=%f K, T(calib BB)=%f K\nrms=%f K, weight=%f\n",
	  (*profile).rx_status.tsys,(*profile).rx_status.trx,(*profile).rx_status.calib,
	  (*profile).rx_status.rms,(*profile).rx_status.weight);
  if((*profile).sys_head.version>1){
    fprintf(msg_fp,"scale=%f\n",(*profile).rx_status.scale);
  }
}

void print_backend(msg_fp,list_flag,profile,label_flag)
FILE *msg_fp; /* <in> */
PRF_HEADER *list_flag;
PROFILE *profile;
int label_flag;
{
  fprintf(msg_fp,"backend name=%s\n",(*profile).be_status.name);
  fprintf(msg_fp,"backend total channel=%d, profile data total channel=%d\n",
	  (*profile).be_status.be_ch,(*profile).be_status.data_ch);
  fprintf(msg_fp,"nominal center freq=%e MHz, backend basis channel (ch0)=%d\n",
	  (*profile).be_status.center_freq,(*profile).be_status.basis_ch);
  if((*profile).sys_head.version>2){
    fprintf(msg_fp,"center_ch(ch0)=%f\n",(*profile).be_status.center_ch);
  }
  fprintf(msg_fp,"RF freq ");
  if((*profile).be_status.sign>0)
    fprintf(msg_fp,"increases");
  else
    fprintf(msg_fp,"decreases");
  fprintf(msg_fp," in ch number increasing\n");
  fprintf(msg_fp,"backend dispersion x=ch-ch0, f(MHz)=a+b*x+c*x^2+d*x^3+e*x^4\n");
  fprintf(msg_fp,"%e, %e, %e, %e, %e\n",
	  (*profile).be_status.disp0,(*profile).be_status.disp1,
	  (*profile).be_status.disp2,(*profile).be_status.disp3,
	  (*profile).be_status.disp4);
  fprintf(msg_fp,"backend resolution=%f MHz\n",(*profile).be_status.freq_res);
  fprintf(msg_fp,"one ch in data = backend %f ch, first ch in data = backend %f ch\n",
	  (*profile).be_status.ch_width,(*profile).be_status.ch_orig);
}

void print_obs_log(msg_fp,list_flag,profile,label_flag)
FILE *msg_fp; /* <in> */
PRF_HEADER *list_flag;
PROFILE *profile;
int label_flag;
{
  fprintf(msg_fp,"observation site=%s\n",(*profile).obs_log.site_name);
  fprintf(msg_fp,"atm temp=%f C, atm water=%f hPa, atm press=%f hPa\n",
	  (*profile).obs_log.meteo.tmp,(*profile).obs_log.meteo.water,
	  (*profile).obs_log.meteo.press);
  fprintf(msg_fp,"opacity of the atmosphere at zenith=%f\n",
	  (*profile).obs_log.tau0);
  fprintf(msg_fp,"%s\n",(*profile).obs_log.memo);
  fprintf(msg_fp,"%s\n",(*profile).obs_log.comment);
}

void print_history(msg_fp,list_flag,profile,label_flag)
FILE *msg_fp; /* <in> */
PRF_HEADER *list_flag;
PROFILE *profile;
int label_flag;
{
  int ii,jj;

  for(ii=0;ii<=(*profile).sys_head.hist_step;ii++) {
    fprintf(msg_fp,"%s, ",(*profile).history[ii].step);
    fprintf(msg_fp,"time=%s",ctime(&(*profile).history[ii].time));
    for(jj=0;jj<(*profile).history[ii].size;jj++) {
      fprintf(msg_fp,"%s\n",(*profile).history[ii].prm[jj]);
    }
  }
  fprintf(msg_fp,"\n");
}

void print_spurious(msg_fp,list_flag,profile,label_flag)
FILE *msg_fp; /* <in> */
PRF_HEADER *list_flag;
PROFILE *profile;
int label_flag;
{
  int ii;
  int sp_flag;

  for(ii=1;ii<=(*profile).be_status.data_ch;ii++) {
    if(ii==(ii-1)/50*50+1){
      fprintf(msg_fp,"\nch=%4d",ii);
    }
    if(ii==(ii-1)/10*10+1){
      fprintf(msg_fp," ");
    }
    if(ii==(ii-1)/5*5+1){
      fprintf(msg_fp," ");
    }

    sp_flag=StarReadSpuriousFlag(profile,ii);
    if(sp_flag==FLAGGED){
      fprintf(msg_fp,"1");
    }else{
      fprintf(msg_fp,"0");
    }
  }
  fprintf(msg_fp,"\n");
}


void print_baseline(msg_fp,list_flag,profile,label_flag)
FILE *msg_fp; /* <in> */
PRF_HEADER *list_flag;
PROFILE *profile;
int label_flag;
{
  int ii;
  int bs_flag;

  for(ii=1;ii<=(*profile).be_status.data_ch;ii++) {
    if(ii==(ii-1)/50*50+1){
      fprintf(msg_fp,"\nch=%4d",ii);
    }
    if(ii==(ii-1)/10*10+1){
      fprintf(msg_fp," ");
    }
    if(ii==(ii-1)/5*5+1){
      fprintf(msg_fp," ");
    }

    bs_flag=StarReadBaselineFlag(profile,ii);
    if(bs_flag==FLAGGED){
      fprintf(msg_fp,"1");
    }else{
      fprintf(msg_fp,"0");
    }
  }
  fprintf(msg_fp,"\n");
}

void print_header(msg_fp,argc,argv,profile,block_flag,list_flag,label_flag)
FILE *msg_fp; /* <in> */
int	argc;
char	*argv[];
PROFILE	*profile;
int *block_flag;
PRF_HEADER	*list_flag;
int	label_flag;
{
/* print headers */
  if(label_flag>0) {
    fprintf(msg_fp,"--- header list of profile data ---\n");
    fprintf(msg_fp,"name=%s\n",(*profile).file_name);
  }

  if(block_flag[0]>0) {
    if(label_flag>0)
      fprintf(msg_fp,"--- system header\n");
    print_sys_head(msg_fp,&list_flag,profile,label_flag);
  }

  if(block_flag[1]>0) {
    if(label_flag>0)
      fprintf(msg_fp,"--- observation parameters\n");
    print_obs_prm(msg_fp,&list_flag,profile,label_flag);
  }

  if(block_flag[2]>0) {
    if(label_flag>0)
      fprintf(msg_fp,"--- object parameters\n");
    print_object(msg_fp,&list_flag,profile,label_flag);
  }

  if(block_flag[3]>0) {
    if(label_flag>0)
      fprintf(msg_fp,"--- antenna parameters\n");
    print_antenna(msg_fp,&list_flag,profile,label_flag);
  }

  if(block_flag[4]>0) {
    if(label_flag>0)
      fprintf(msg_fp,"--- receiver paramaters\n");
    print_receiver(msg_fp,&list_flag,profile,label_flag);
  }

  if(block_flag[5]>0) {
    if(label_flag>0)
      fprintf(msg_fp,"--- backend parameters\n");
    print_backend(msg_fp,&list_flag,profile,label_flag);
  }

  if(block_flag[6]>0) {
    if(label_flag>0)
      fprintf(msg_fp,"--- observation log\n");
    print_obs_log(msg_fp,&list_flag,profile,label_flag);
  }

  if(block_flag[7]>0) {
    if(label_flag>0)
      fprintf(msg_fp,"--- history log\n");
    print_history(msg_fp,&list_flag,profile,label_flag);
  }

  if(block_flag[8]>0) {
    if(label_flag>0)
      fprintf(msg_fp,"--- spurious flag");
    print_spurious(msg_fp,&list_flag,profile,label_flag);
  }

  if(block_flag[9]>0) {
    if(label_flag>0)
      fprintf(msg_fp,"--- baseline flag");
    print_baseline(msg_fp,&list_flag,profile,label_flag);
  }

  return;
}

void print_1line_header(msg_fp,msg_format,profile)
FILE *msg_fp; /* <in> */
int msg_format; /* <in> =1; 1 line, =2; 2 lines */
PROFILE	*profile; /* <in> */
{
  char date[256];
  int l_date;
  time_t obs_time;

  obs_time=(time_t)((*profile).obs_prm.start);
  strcpy(date,ctime(&obs_time));
  if(msg_format==1) {
    l_date=strlen(date);
    if(date[l_date-1]=='\n') date[l_date-1]=(char)NULL;
  }

  fprintf(msg_fp,"%ld\t%s\t%s\t%d\t",(*profile).sys_head.scan,date,(*profile).obs_prm.scd_file,(*profile).obs_prm.line_numb);
  fprintf(msg_fp,"%f\t%f\t%f\t%f\t%f\t%f\t",(*profile).object.on_lb.x,(*profile).object.on_lb.y,(*profile).object.on_radec.x,(*profile).object.on_radec.y,(*profile).object.on_azel.x,(*profile).object.on_azel.y);
  fprintf(msg_fp,"%f\t%f",(*profile).rx_status.v_lsr,(*profile).rx_status.rms);
  fprintf(msg_fp,"\n");

  return;
}

int main(argc,argv)
int argc;
char *argv[];
{
  PROFILE profile;
  PRF_HEADER list_flag;
  int pipe_flag;
  int label_flag;
  int short_msg_flag;
  int msg_fp_flag;

  int block_flag[N_BLOCK];
  int err_code;
  int i_file,n_file;
  char id_str[BUFFER_SIZE];

  int sdb_flag;
  char sdb_arg[MAX_IDX_RECORD_LENGTH];

  FILE *msg_fp;

/* option setting */
  options(argc,argv,block_flag,&list_flag,&pipe_flag,&label_flag,&short_msg_flag,&msg_fp_flag);

  StarPipeHeadIn(id_str,&n_file);
  if(pipe_flag>0) StarPipeHeadOut(n_file);

  if(msg_fp_flag==1) {
    msg_fp=stdout;
  } else {
    msg_fp=stderr;
  }

  for(i_file=0;i_file<n_file;i_file++) {

/* profile from stdin */
    err_code=StarProfileIn(&profile,&sdb_flag,sdb_arg);
    if(err_code!=0)	{
      if(pipe_flag>0) StarPipeEndOut();
      exit(1);
    }

/* profile to stdout */
    if(pipe_flag>0)
      err_code=StarProfileOut(&profile,sdb_flag,sdb_arg);

/* print header in stderr */
    if(sdb_flag==GOOD_SCAN || sdb_flag==BAD_SCAN) {
      if(short_msg_flag>0) {
	print_1line_header(msg_fp,short_msg_flag,&profile);
      } else {
	print_header(msg_fp,argc,argv,&profile,block_flag,&list_flag,label_flag);
      }
    }
  }
  if(pipe_flag>0) StarPipeEndOut();
  exit(0);
}
