/*
make .sdb flow from .scn flow

1998/4/23 T.Handa : ver.3.0
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <StData.h>
#include <StStd.h>

#define	DEFAULT_PRMFILE	"scn2sdb.prm"
#define N_KEY 30
#define N_BLOCK	10


int main(argc,argv)
int	argc;
char	*argv[];
{
  PROFILE profile;
  int err_code;
  int i_file,n_file;
  char id_str[BUFFER_SIZE];

  int sdb_flag;
  char sdb_arg[MAX_IDX_RECORD_LENGTH];
  static char default_sdbname[]="default";
  static int backup_ver=0;

  StarPipeHeadIn(id_str,&n_file);

/* header out */
  StarSdbHeadOut(default_sdbname,n_file,backup_ver);

  for(i_file=0;i_file<n_file;i_file++) {

/* ProfileIn */
    err_code=StarProfileIn(&profile,&sdb_flag,sdb_arg);
    if(err_code!=0) {
      exit(1);
    }

/* SdbOut */
    err_code=StarSdbOut(profile.file_name,sdb_flag,sdb_arg);
  }
  exit(0);
}
