#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

int is_extra_visible_char(letter)
char letter; /* <in> letter to check */
/*
check the character whether non-alphanumeric but visible ASCII or not
<return> =1 Yes, =0 No
2004/12/1 T.Handa
 */
{
  static char sample[32]="!?\"#$%&\'()~=|+-*/^_`{}@[];:<>,.";
  static int n_sample=31;
  int ii;

  for(ii=0;ii<n_sample;ii++) {
    if(letter==sample[ii]) {
      return(1);
    }
  }

  return(0);
}

int check_char_type(letter)
char letter; /* <in> letter to check */
/*
check the character
<return>
1 aplphabet (a-zA-Z)
2 digit (0-9)
3 extraASCII but visible
4 space
0 others

2004/12/1 T.Handa
 */
{
  if(is_extra_visible_char(letter)==1)
    return(3);
  if(isalpha((int)letter)!=0)
    return(1);
  if(isdigit((int)letter)!=0)
    return(2);
  if(letter==' ')
    return(4);
  return(0);
}


void minstrcpy(outp,inp,i_str,n_str)
char *outp; /* <out> output c-strings */
char *inp; /* <in> input characters */
int i_str; /* <in> start address of input */
int n_str; /* <in> effective length of input */
{
  int ii;
  int l_str;
  int i_type;

  l_str=strlen(inp);
  if(l_str<n_str) n_str=l_str;
  strncpy(outp,&(inp[i_str]),n_str);
  outp[n_str]=(char)NULL;

  for(ii=n_str-1;ii>=0;ii--) {
    i_type=check_char_type(outp[ii]);
    if(i_type>0 && i_type<4) {
      outp[ii+1]=(char)NULL;
      break;
    }
  }

  return;
}

main(argc,argv)
int argc;
char **argv;
{
  char outp[256],inp[256];

  gets(inp);
  minstrcpy(outp,inp,0,255);
  printf("%s:::-->%s:::\n",inp,outp);
}
