#!/bin/sh
#
# check install directory
#   recursively-mkdir
#
# 2007/2/20 T.Handa
#
if [ "$1" = "" ]; then
    exit
fi
target_dir=$1

if [ -f $target_dir ]; then
    echo $target_dir is a file.
    echo Change the current name. $target_dir will be used to install.
    exit
elif [ -d $target_dir ]; then
    echo Use $target_dir for installation.
else
    n_dir=`echo $target_dir | sed s+/+\ +g | wc | awk '{print $2}'`
    let max_pos=n_dir+1
    first_letter=`echo $target_dir | awk '{print substr($0,1,1)}'`
    if [ "$first_letter" = "/" ] ; then
	i_pos=2
    else
	i_pos=1
    fi
    
    while [ $i_pos -le $max_pos ]; do
	parent_dir=`echo $target_dir | sed s+/+\ +$i_pos | awk '{print $1}'`
	let i_pos=i_pos+1
	if [ -f $parent_dir ]; then
	    echo $parent_dir is a file.
	    echo Change the current name. $parent will be used to install.
	    exit
	elif [ -d $parent_dir ]; then
	    echo Use $parent_dir for installation.
	else
	    mkdir $parent_dir
	    echo mkdir $parent_dir
	fi
    done
fi
